<?php

namespace Bushelpowered\Api\Platform\Eventstore\Common;

class SerializationToken
{
    public string $type;
    public $data = null;
    private \JsonMapper $mapper;

    private static $types = [
        'initial' => '\Bushelpowered\Api\Common\EmptyPHP',
        'value' => null,
    ];

    private function __construct($type, $data) {
        $this->type = $type;
        $this->data = $data;
        $this->mapper = new \JsonMapper();
    }

    public static function Initial(?\Bushelpowered\Api\Common\EmptyPHP $data): SerializationToken
    {
        return new SerializationToken('initial', $data);
    }
    public static function Value(string $data): SerializationToken
    {
        return new SerializationToken('value', $data);
    }

    public function getData() {
        $className = self::$types[$this->type];
        if ($className != null && $this->data != null) {
            $empty = (new \ReflectionClass($className))->newInstanceWithoutConstructor();
            return $this->mapper->map($this->data, $empty);
        } else {
            return $this->data;
        }
    }
}
    